﻿using System;

namespace InterfaceDemo
{
    // Define the interface
    interface IClient
    {
        void Order(int orderNum);
        string name { get; set; }
        string address { get; set; }

    }

    // Create a Customer class that implements the IClient interface
    public class Customer : IClient
    {
        public string name { get; set; }
        public string address { get; set; }

        public Customer(string s)
        {
            Console.WriteLine("Creating a New Customer ID: {0}", s);
        }

        // Implement the Order method
        public void Order(int newOrder)
        {
            Console.WriteLine(
                "Implementing the Order Method for IClient. The Order Number is: {0}", newOrder);
        }
    }

    class Tester
    {
        public void Run()
        {
            Customer cust = new Customer("H56388");
            cust.name = "Brian Ferry";
            cust.address = "23 Orange Lane, Clifton, Bristol, BS6 5FH";
            Console.WriteLine("The Name of the Customer is: {0}", cust.name);
            Console.WriteLine("The Address of the Customer is: {0}", cust.address);
            cust.Order(1234);
        }

        [STAThread] 
        static void Main()
        {
            Tester t = new Tester();
            t.Run();
            Console.ReadLine();
        }
    }
}